/********************************************************************
//DM430-LͿRS485ͨʵ飬ͨԽͨţ485UART1
//Զ˱رRS232תRS485ģ飬޷ֱӵ
//RS485֮ͨ˫ӣԲʹ120ŷƥ
//ԶͨڵֲȽɵԷ
//Ὣյٷ͵ڵ֣ղжģ飬òѯ
//صBSLģͨñΪUSBתģʽʼǱûдڿֱӴ
//BSLRXDTXD0ӣTXDRXD0Ӽ
//עʹBSLģΪUSBתڹܵʱRTSTCKñDTRRESETñҪϿ
//ʸͨconfig.hļֱӸbaud
//ԻEW430 V5.30
//ߣ www.avrgcc.com
//ʱ䣺2011.09.19
********************************************************************/

#include <msp430x14x.h>

#define CPU_F ((double)8000000) 
#define delay_us(x) __delay_cycles((long)(CPU_F*(double)x/1000000.0)) 
#define delay_ms(x) __delay_cycles((long)(CPU_F*(double)x/1000.0)) 

#define uchar unsigned char
#define uint  unsigned int
#define ulong unsigned long

/*BRCLK=CPU_FʱĹʽԼ㣬ҪüƵϵ*/
#define baud           9600                                //òʵĴС
#define baud_setting   (uint)((ulong)CPU_F/((ulong)baud))  //ʼ㹫ʽ
#define baud_h         (uchar)(baud_setting>>8)            //ȡλ
#define baud_l         (uchar)(baud_setting)               //λ

/*RS485ƹܽ*/
#define RS485_CTR1      P5OUT |= BIT2;          //øߣRS485״̬
#define RS485_CTR0      P5OUT &= ~BIT2;         //õͣRS485״̬

//***********************************************************************
//               MSP430IOڳʼ
//***********************************************************************
void Port_Init()
{
  P5DIR |= BIT2;                        //P20ΪRS485ƿڣģʽ
  P5OUT |= BIT2;                        //øP20
}


//***********************************************************************
//                   ϵͳʱӳʼ
//***********************************************************************
void Clock_Init()
{
  uchar i;
  BCSCTL1&=~XT2OFF;                 //XT2
  BCSCTL2|=SELM1+SELS;              //MCLKΪ8MHZSMCLKΪ8MHZ
  do{
    IFG1&=~OFIFG;                   //־
    for(i=0;i<100;i++)
       _NOP();
  }
  while((IFG1&OFIFG)!=0);           //־λ1ѭȴ
  IFG1&=~OFIFG; 
}
//***********************************************************************
//               MSP430ڲŹʼ
//***********************************************************************
void WDT_Init()
{
   WDTCTL = WDTPW + WDTHOLD;       //رտŹ
}

//*************************************************************************
//               MSP430ڳʼ
//*************************************************************************
void UART_Init()
{
  U1CTL|=SWRST + CHAR;                //λSWRST8λģʽ
  U1TCTL|=SSEL1;                      //SMCLKΪʱ
  U1BR1=baud_h;                       //BRCLK=8MHZ,Baud=BRCLK/N
  U1BR0=baud_l;                       //N=UBR+(UxMCTL)/8
  U1MCTL=0x00;                        //΢ĴΪ09600bps
  ME2|=UTXE1;                         //UART1ʹ
  ME2|=URXE1;                         //UART1ʹ
  U1CTL&=~SWRST;
  IE2|=URXIE1;                        //жʹλ
  
  P3SEL|= BIT6 + BIT7;                //IOΪڶģʽUART
  P3DIR|= BIT6;                       //TXD1ڷΪ
}

//*************************************************************************
//              1ݺ
//*************************************************************************

void Send_Byte(uchar data)
{
  RS485_CTR1;
  while(!(IFG2&UTXIFG1));             //ͼĴյʱ
  U1TXBUF=data;
  //RS485_CTR0;
}

//*************************************************************************
//              1ַ
//*************************************************************************
void Print_Str(uchar *s)
{
  while(*s != '\0')
    {
        Send_Byte(*s++);
        delay_ms(2);
    }
}

//*************************************************************************
//               Դ1Ľж
//*************************************************************************

#pragma vector=UART1RX_VECTOR
__interrupt void UART1_RX_ISR(void)
{
  uchar data=0;
  
  data=U1RXBUF;                       //յݴ
  Send_Byte(data);                    //յٷͳȥ
  delay_ms(5);                        //л֮ǰиСʱ
  RS485_CTR0;                         //л״̬
}

//*************************************************************************
//           
//*************************************************************************
void main(void)
{ 
  WDT_Init();                         //Ź
  Clock_Init();                       //ϵͳʱ
  Port_Init();                        //˿ڳʼ
  UART_Init();                        //óʼ
  Print_Str("DM430-A Board UART Test\n"); //ַ
  RS485_CTR0;                         //л״̬
  _EINT();                            //ж
  while(1)                            //ѭ
    {
    }
}