/********************************************************************
//DM430-LСϵͳ崮ڲԳʹõƬĴ0
//ͨ봮ӿ崮ʹôڵַݵϵͳ
//ϵͳὫյٷ͵ڵ֣ղжģ飬òѯ
//صBSLģͨñΪUSBתģʽʼǱûдڿֱӴ
//BSL_ConfigRXDTXD0ӣTXDRXD0Ӽ
//ԻEW430 V5.30
//ߣ www.avrgcc.com
//ʱ䣺2011.09.19
********************************************************************/

#include <msp430x14x.h>

#define CPU_F ((double)8000000) 
#define delay_us(x) __delay_cycles((long)(CPU_F*(double)x/1000000.0)) 
#define delay_ms(x) __delay_cycles((long)(CPU_F*(double)x/1000.0)) 

#define uchar unsigned char
#define uint  unsigned int
#define ulong unsigned long

/*BRCLK=CPU_FʱĹʽԼ㣬ҪüƵϵ*/
#define baud           9600                                //òʵĴС
#define baud_setting   (uint)((ulong)CPU_F/((ulong)baud))  //ʼ㹫ʽ
#define baud_h         (uchar)(baud_setting>>8)            //ȡλ
#define baud_l         (uchar)(baud_setting)               //λ

//*************************************************************************
//                    ϵͳʱӳʼ
//*************************************************************************
void Clock_Init()
{
  uchar i;
  BCSCTL1&=~XT2OFF;                 //XT
  BCSCTL2|=SELM1+SELS;              //MCLKΪ8MHZSMCLKΪ8MHZ
  do{
    IFG1&=~OFIFG;                   //𵴱־
    for(i=0;i<100;i++)
       _NOP();                      //ʱȴ
  }
  while((IFG1&OFIFG)!=0);           //־Ϊ1ѭȴ
  IFG1&=~OFIFG; 
}
//*************************************************************************
//              MSP430ڲŹʼ
//*************************************************************************
void WDT_Init()
{
   WDTCTL = WDTPW + WDTHOLD;       //رտŹ
}

//*************************************************************************
//               MSP430ڳʼ
//*************************************************************************
void UART_Init()
{
  U0CTL|=SWRST;               //λSWRST
  U0CTL|=CHAR;                //8λģʽ 
  U0TCTL|=SSEL1;              //SMCLKΪʱ
  U0BR1=baud_h;               //BRCLK=8MHZ,Baud=BRCLK/N
  U0BR0=baud_l;               //N=UBR+(UxMCTL)/8
  U0MCTL=0x00;                //΢ĴΪ09600bps
  ME1|=UTXE0;                 //UART1ʹ
  ME1|=URXE0;                 //UART1ʹ
  U0CTL&=~SWRST;
  IE1|=URXIE0;                //жʹλ
  
  P3SEL|= BIT4;               //IOΪͨI/Oģʽ
  P3DIR|= BIT4;               //IOڷΪ
  P3SEL|= BIT5;
}

//*************************************************************************
//              0ݺ
//*************************************************************************

void Send_Byte(uchar data)
{
  while((IFG1&UTXIFG0)==0);          //ͼĴյʱ
    U0TXBUF=data;
}

//*************************************************************************
//               Դ 0 Ľж
//*************************************************************************

#pragma vector=UART0RX_VECTOR
__interrupt void UART0_RX_ISR(void)
{
  uchar data=0;
  data=U0RXBUF;                       //յݴ
  Send_Byte(data);                    //յٷͳȥ
}

//*************************************************************************
//            Դ 0 ķжϣԤ
//*************************************************************************

#pragma vector=UART0TX_VECTOR
__interrupt void UART0_TX_ISR(void)
{

}

//*************************************************************************
//           
//*************************************************************************
void main(void)
{ 
  WDT_Init();                         //Ź
  Clock_Init();                       //ϵͳʱ
  UART_Init();                        //óʼ
  _EINT();                            //ж
  while(1)                            //ѭ
    {
    }
}