/********************************************************************
//DM430-LСϵͳƴֿ12864ҺģʾԳ
//ʾģʽΪģʽֱӽ1286412864ӿڼ
//עѡҺĵԴλڵλѡ5V3.3VҺѹѡ
//ԻEW430 V5.30
//ߣ www.avrgcc.com
//ʱ䣺2011.09.19
********************************************************************/
#include <msp430x14x.h>

#define CPU_F ((double)8000000) 
#define delay_us(x) __delay_cycles((long)(CPU_F*(double)x/1000000.0)) 
#define delay_ms(x) __delay_cycles((long)(CPU_F*(double)x/1000.0)) 

#define uchar unsigned char
#define uint  unsigned int
#define ulong unsigned long

/*12864Ӧָ*/
#define CLEAR_SCREEN	0x01		    //ָACֵΪ00H
#define AC_INIT		0x02		    //ACΪ00HαƵԭλ
#define CURSE_ADD	0x06		    //趨αƵͼƶĬαƣͼ岻
#define FUN_MODE	0x30		    //ģʽ8λָ
#define DISPLAY_ON	0x0c		    //ʾ,ʾα꣬αλ÷
#define DISPLAY_OFF	0x08		    //ʾ
#define CURSE_DIR	0x14		    //αƶ:AC=AC+1
#define SET_CG_AC	0x40		    //ACΧΪ00H~3FH
#define SET_DD_AC	0x80

#define P50 0
#define P51 1
#define P55 5
#define P56 6
#define P57 7

#define RS_CLR	P5OUT &= ~(1 << P55)        //RSõ
#define RS_SET	P5OUT |= (1 << P55)         //RSø

#define RW_CLR	P5OUT &= ~(1 << P56)        //RWõ
#define RW_SET	P5OUT |= (1 << P56)         //RWø

#define EN_CLR	P5OUT &= ~(1 << P57)        //Eõ
#define EN_SET	P5OUT |= (1 << P57)         //Eø

#define PSB_CLR	P5OUT &= ~(1 << P50)        //PSBõͣڷʽ
#define PSB_SET	P5OUT |= (1 << P50)         //PSBøߣڷʽ

#define RST_CLR	P5OUT &= ~(1 << P51)        //RSTõ
#define RST_SET	P5OUT |= (1 << P51)         //RSTø

#define DataPort      P4OUT                 //P4Ϊݿ


//*************************************************************************
//                    ϵͳʱӳʼ
//*************************************************************************
void Clock_Init()
{
  uchar i;
  BCSCTL1&=~XT2OFF;                 //XT
  BCSCTL2|=SELM1+SELS;              //MCLKΪ8MHZSMCLKΪ8MHZ
  do{
    IFG1&=~OFIFG;                   //𵴱־
    for(i=0;i<100;i++)
       _NOP();                      //ʱȴ
  }
  while((IFG1&OFIFG)!=0);           //־Ϊ1ѭȴ
  IFG1&=~OFIFG; 
}
//*************************************************************************
//              MSP430ڲŹʼ
//*************************************************************************
void WDT_Init()
{
   WDTCTL = WDTPW + WDTHOLD;       //رտŹ
}

//*************************************************************************
//			ʼIOӳ
//*************************************************************************
void Port_init()
{

	P4SEL = 0x00;
        P4DIR = 0xFF;
        P5SEL = 0x00;
        P5DIR|= BIT0 + BIT1 + BIT5 + BIT6 + BIT7;
        PSB_SET;		  //Һڷʽ
	RST_SET;		  //λRSTø
}



//***********************************************************************
//	ʾд뺯
//***********************************************************************


void LCD_write_com(unsigned char com) 
{	
	RS_CLR;
	RW_CLR;
	EN_SET;
	DataPort = com;
	delay_ms(5);
	EN_CLR;
}
//***********************************************************************
//	ʾд뺯
//***********************************************************************

void LCD_write_data(unsigned char data) 
{
	RS_SET;
	RW_CLR;
	EN_SET;
	DataPort = data;
	delay_ms(5);
	EN_CLR;
}
//***********************************************************************
//	ʾʾ
//***********************************************************************

void LCD_clear(void) 
{
	LCD_write_com(0x01);
	delay_ms(5);
}

//***********************************************************************
//ƣDisplayCgrom(uchar hz)ʾCGROMĺ
//***********************************************************************
void DisplayCgrom(uchar addr,uchar *hz)
{
	LCD_write_com(addr);
        delay_ms(5);
	while(*hz != '\0')
	{
		LCD_write_data(*hz);
		hz++;
                delay_ms(5);
	}

} 
//****************************************************************
//ƣDisplay()ʾԽ
//****************************************************************
void Display(void)
{
	DisplayCgrom(0x80,"͵ӻӭ");
	DisplayCgrom(0x88,":jingyehanxing");
	DisplayCgrom(0x90,"www.avrgcc.com  ");
	DisplayCgrom(0x98,"绰057487476870");

}

//***********************************************************************
//	ʾʼ
//***********************************************************************

void LCD_init(void) 
{
	LCD_write_com(FUN_MODE);			//ʾģʽ
	delay_ms(5);
	LCD_write_com(FUN_MODE);			//ʾģʽ
	delay_ms(5);
        LCD_write_com(DISPLAY_ON);			//ʾ
	delay_ms(5);
        LCD_write_com(CLEAR_SCREEN);			//
	delay_ms(5);
}
//***********************************************************************
//      
//***********************************************************************
void main(void)
{
        WDT_Init();                                   //Ź
        Clock_Init();                                 //ϵͳʱ
        Port_init();                                  //ϵͳʼIO
	delay_ms(100);                                //ʱ100ms
	LCD_init();                                   //Һʼ
	LCD_clear();                                  //
	while(1)
	{
	Display();                                    //ʾ
	}
}