/********************************************************************
//DM430-LСϵͳ1602ҺģʾԳ
//ֱӽ16021602ӿڼ
//עѡҺĵԴλڵλѡ5V3.3VҺѹѡ
//ԻEW430 V5.30
//ߣ www.avrgcc.com
//ʱ䣺2011.09.19
********************************************************************/
#include <msp430x14x.h>

#define CPU_F ((double)8000000) 
#define delay_us(x) __delay_cycles((long)(CPU_F*(double)x/1000000.0)) 
#define delay_ms(x) __delay_cycles((long)(CPU_F*(double)x/1000.0)) 

#define uchar unsigned char
#define uint  unsigned int
#define ulong unsigned long

#define P55 5
#define P56 6
#define P57 7

#define RS_CLR	P5OUT &= ~(1 << P55)        //RSõ
#define RS_SET	P5OUT |= (1 << P55)         //RSø

#define RW_CLR	P5OUT &= ~(1 << P56)        //RWõ
#define RW_SET	P5OUT |= (1 << P56)         //RWø

#define EN_CLR	P5OUT &= ~(1 << P57)        //Eõ
#define EN_SET	P5OUT |= (1 << P57)         //Eø

#define DataPort      P4OUT                 //P4Ϊݿ


//*************************************************************************
//                    ϵͳʱӳʼ
//*************************************************************************
void Clock_Init()
{
  uchar i;
  BCSCTL1&=~XT2OFF;                 //XT
  BCSCTL2|=SELM1+SELS;              //MCLKΪ8MHZSMCLKΪ8MHZ
  do{
    IFG1&=~OFIFG;                   //𵴱־
    for(i=0;i<100;i++)
       _NOP();                      //ʱȴ
  }
  while((IFG1&OFIFG)!=0);           //־Ϊ1ѭȴ
  IFG1&=~OFIFG; 
}
//*************************************************************************
//              MSP430ڲŹʼ
//*************************************************************************
void WDT_Init()
{
   WDTCTL = WDTPW + WDTHOLD;       //رտŹ
}

//*************************************************************************
//			ʼIOӳ
//*************************************************************************
void Port_init()
{

	P4SEL = 0x00;
        P4DIR = 0xFF;
        P5SEL = 0x00;
        P5DIR|= BIT5 + BIT6 + BIT7;     //ƿΪģʽ
}



//***********************************************************************
//	ʾд뺯
//***********************************************************************


void LCD_write_com(unsigned char com) 
{	
	RS_CLR;
	RW_CLR;
	EN_SET;
	DataPort = com;                 //д˿
	delay_ms(5);
	EN_CLR;
}
//***********************************************************************
//	ʾд뺯
//***********************************************************************

void LCD_write_data(unsigned char data) 
{
	RS_SET;
	RW_CLR;
	EN_SET;
	DataPort = data;                //д˿
	delay_ms(5);
	EN_CLR;
}
//***********************************************************************
//	ʾʾ
//***********************************************************************

void LCD_clear(void) 
{
	LCD_write_com(0x01);            //Ļʾ
	delay_ms(5);
}
//***********************************************************************
//	ʾַд뺯
//***********************************************************************

void LCD_write_str(unsigned char x,unsigned char y,unsigned char *s) 
{
	
    if (y == 0) 
    {
    	LCD_write_com(0x80 + x);        //һʾ
    }
    else 
    {
    	LCD_write_com(0xC0 + x);        //ڶʾ
    }
    
    while (*s) 
    {
    	LCD_write_data( *s);
    	s ++;
    }
}
//***********************************************************************
//	ʾַд뺯
//***********************************************************************

void LCD_write_char(unsigned char x,unsigned char y,unsigned char data) 
{
	
    if (y == 0) 
    {
    	LCD_write_com(0x80 + x);        //һʾ
    }
    else 
    {
    	LCD_write_com(0xC0 + x);        //ڶʾ
    }
    
    LCD_write_data( data);  
}
//***********************************************************************
//	ʾʼ
//***********************************************************************

void LCD_init(void) 
{
    LCD_write_com(0x38);		//ʾģʽ  
    delay_ms(5);
    LCD_write_com(0x08);		//ʾر
    delay_ms(5);
    LCD_write_com(0x01);		//ʾ
    delay_ms(5);
    LCD_write_com(0x06);		//ʾƶ
    delay_ms(5);
    LCD_write_com(0x0C);		//ʾ
    delay_ms(5);
}
//***********************************************************************
//      
//***********************************************************************
void main(void)
{
     uchar i,*p;
     WDT_Init();                         //Ź
     Clock_Init();                       //ϵͳʱ
     Port_init();                        //ϵͳʼIO
     delay_ms(100);                      //ʱ100ms
     LCD_init();                         //Һʼ
     LCD_clear();                        //
     while (1) 
      {
		i = 1;
		p = "www.avrgcc.com";                //ַʾ
		LCD_clear();
		LCD_write_str(0,0,"Welcome");
		delay_ms(250);
		
		while (*p) {
			LCD_write_char(i,1,*p);      //ַʾ
			i ++;
			p ++;
			delay_ms(250);               //ʱ250ms
			}
		delay_ms(250);
      }
}